program sortieren_batch;

{$mode delphi}

uses
  Windows, Messages, SysUtils, Classes;

const eingabe : string = 'test.txt';
      ausgabe : string = 'sort.txt';

var
  datei : TStringList;

function myCompare(liste: TStringList; i1, i2: longint):longint;
var
  r, i, l, l1, l2: longint;
  c1, c2: byte;
  s1, s2: String;
begin
   s1:= liste[i1]; s2:= liste[i2];
   l1:= s1.Length; l2:= s2.Length;
   i:= 1; r:= 0;
   l:= l1; if l > l2 then l:= l2;
   while (r = 0) and (i <= l) do begin
     c1:= ORD(s1[i]); c2:= ORD(s2[i]);
     if c1 < c2 then r:= -1 else
     if c1 > c2 then r:= 1;
     inc(i);
   end;
   if r = 0 then begin
     if l1 < l2 then r:= -1 else
     if l1 > l2 then r:= 1;
   end;
   Result:= r;
end;

begin
  if paramstr(1)<>'' then eingabe:=paramstr(1);
  if paramstr(2)<>'' then ausgabe:=paramstr(2);
  datei:=TStringList.Create;
  datei.LoadFromFile(eingabe);
  //datei.Sort;
  datei.Customsort(myCompare);
  datei.SaveToFile(ausgabe);
end.
